/*!
 * china_api_login 跨域登录
 * http://www.china.com
 *
 * Copyright (c) 2011 china.com
 *
 * Date: 2017-1
 * Revision: k3.0
 * Edit: F7
 */

(function(window){
	var hash = {};
	var getScript = function(url, data, callback, scriptCharset){
		var head, script, iscss = false;

		if ( url.indexOf(".css") > -1 ) {
			iscss = true;
		};
		
		if(data){ url += '?' + encodeURI(data); };
		
		if(!hash.createScript){ hash.createScript = {} };// 建立专属createScript的杂物堆放处  用于记录已经加载了的script
		if(hash.createScript[url]){
			if(callback){ callback.call(window) };
			return false;
		}else{
			hash.createScript[url] = true;
		};
		
		head = document.getElementsByTagName("head")[0] || document.documentElement;
		
		if ( iscss ) {
			script = document.createElement("link");
			script.rel = "stylesheet";
		} else {
			script = document.createElement("script");
		};
		
		
		if(scriptCharset){ script.charset = scriptCharset; };
		
		if ( iscss ) {
			script.href = url;
		} else {
			script.src = url;
		};

		
		// script加载处理
		//if (!jsonp) {
			var done = false;
			// 处理浏览器兼容
			script.onload = script.onreadystatechange = function() {
				if ( !done && (!this.readyState || this.readyState === "loaded" || this.readyState === "complete") ) {
					done = true;
					if(callback){ callback.call(window) };
					
					// 处理IE内存泄漏
					script.onload = script.onreadystatechange = null;
					if ( head && script.parentNode && !iscss ) {
						head.removeChild( script );
					}
				}
			};
		//}
		
		head.insertBefore( script, head.firstChild );
	};
	var user = {};// 存储已登录用户的信息

	var login_instantiation = [],// 记录页面内实例化的名称
		isIE = /msie (\d+\.\d+)/i.test(navigator.userAgent) ? (document.documentMode || + RegExp['\x241']) : undefined;
	
	function getCookie(name) {
		var arr = document.cookie.match(new RegExp("(^| )"+name+"=([^;]*)(;|$)"));
		if(arr != null){
			return unescape(arr[2]);
		};
		return null;
	};

	function clearCookie (name, path, domain) {
		if (getCookie(name)) {
			document.cookie = name + "=" + ((path) ? "; path=" + path : "; path=/") + ((domain) ? "; domain=" + domain : "") + ";expires=Fri, 02-Jan-1970 00:00:00 GMT";
		}
	};

	// 多点处理【仅修正HTML】登录成功、推出成功都执行此操作
	var login_batch = function(){
		for(var i=0,l=login_instantiation.length; i<l; i++){
			window[login_instantiation[i]].setHTML();
		}
	};
	
	// 专用于外部退出功能
	var login_outer = {};
	login_outer.postOut = function(callback){
		if(callback) login_outer.callback = callback;
		if(typeof login_en_lan_confirm == "string"?login_en_lan_confirm:"Confirm logout?"){//确认退出？
			getScript("https://passport.china.com/chinaapi/jsonp/userLogout", "ticket="+ getCookie("ticket") +"&jsonpcallback=china_api_login_outerOutCallback");
			return false;
		}
	};
	var outer_out_callback = function(){
		// 清楚Cookie
		clearCookie("nickname");
		clearCookie("ticket");
		clearCookie("username");

		if(login_outer.callback) login_outer.callback();
		login_batch();
	};
	window.china_api_login_work = login_outer;
	window.china_api_login_outerOutCallback = outer_out_callback;
	/* 对外退出功能结束 */
	
	
	// 检测用户是否登录或者登录后返回nickname
	login_outer.getNickname = function(callback){
		if(!getCookie("nickname")){
			return false;
		}else{
			return getCookie("nickname");
		};
	};
	login_outer.getUsername = function(callback){
		if(!getCookie("username")){
			return false;
		}else{
			return getCookie("username");
		};
	};
	window.china_api_login_nickname = login_outer.getNickname;
	window.china_api_login_username = login_outer.getUsername;
	
	
	// 主函数
	var Login = function(o){
		this.params = {};
		//console.log(o.name);
		
		this.init(o);
	};
	Login.prototype.model = function(who, methods){
		var n;
		for(n in methods){
			who[n] = methods[n];
		}
	};
	Login.prototype.getCookie = function(name){
		var arr = document.cookie.match(new RegExp("(^| )"+name+"=([^;]*)(;|$)"));
		if(arr != null){
			return unescape(arr[2]);
		};
		return null;
	};
	Login.prototype.setCookie = function(name, value, expires, path, domain){
		if(expires && isNaN(expires) === false){
			expires = new Date(new Date().getTime() + expires);
		};
		document.cookie = name + "=" + escape(value) + ((expires) ? "; expires=" + expires.toGMTString() : "") + ((path) ? "; path=" + path:"; path=/") + ((domain) ? ";domain=" + domain : "");
	};
	
	Login.prototype.trim = function(source){// 清除所有空格
		//var re = new RegExp("(^[\\s\\t\\xa0\\u3000]+)|([\\u3000\\xa0\\s\\t]+\x24)", "g");
		var re = new RegExp(" ", "g");
		return String(source).replace(re, "");
	};
	Login.prototype.init = function(o){
		var that = this;
		this.setParams(o);
		this.setHTML();
		
		/*
		if(!this.getCookie("nickname")){// 未登录 onload后从新设置form CSS
			if(window.addEventListener){
				window.addEventListener("load", loadResetFormCss, false);
			}else if(window.attachEvent){
				window.attachEvent('onload', loadResetFormCss);
			}
		}*/
		if(!this.getCookie("nickname")){
			that.setForm();
		};

		// 初始化结构完成
		if(this.params.initFn) this.params.initFn();
		/*
		function loadResetFormCss(){
			that.setForm();
		};*/
	};
	Login.prototype.setParams = function(o){
		// config params
		this.model(this.params, {
			elem:o.id.nodeType == 1 ? o.id : document.getElementById(o.id),
			//id:o.id.nodeType == 1 ? o.id.getAttribute("id") : o.id,
			userNameInitValue:o.userNameInitValue != undefined ? this.trim(o.userNameInitValue) : "\u6ce8\u518c\u90ae\u7bb1\u002f\u7528\u6237\u540d",// 注册邮箱/用户名
			passwordInitValue:o.passwordInitValue != undefined ? this.trim(o.passwordInitValue) : "",
			initHTML:o.initHTML || "",
			logonHTML:o.logonHTML || "",
			hiddenForm:o.hiddenForm || "",
			initFn:o.initFn || "",
			submitAfterFn:o.submitAfterFn || "",
			submitBackFn:o.submitBackFn || "",
			name:o.name,
			loginUrl: o.loginUrl || "https://passport.china.com/chinaapi/script/userLogon",
			outUrl: o.outUrl || "http://passport1.china.com/user/passportLogoff.do"
		});
		
		// static params
		this.model(this.params, {
			tag_form:'<form name="'+ this.params.name +'_form" method="post" action="">',
			tag_username:'<input type="text" name="username" />',
			tag_password:'<input type="password" name="password" />',
			tag_select_cookietime:'<select name="cookietime"><option value="-1" selected>\u65e0</option><option value="86400">\u4e00\u5929</option><option value="604800">\u4e00\u5468</option><option value="2592000">\u4e00\u6708</option></select>',//无, 一天, 一周, 一月
			tag_checkbox_cookietime:'<input type="checkbox" name="checkbox_cookietime" /><input type="hidden" name="cookietime" value="-1" />',
			tag_out:'<a href="#" onclick="'+ this.params.name +'.out(); return false;">Logout</a>',//退出
			//tag_out:'<a href="#" onclick="console.log('+ this.params.name +'); return false;">\u9000\u51fa</a>',//退出
			succeed:{},
			error: {
				notUserName: function(elem){
					alert("\u8bf7\u8f93\u5165\u7528\u6237\u540d\uff01");//请输入用户名！
					elem.focus();
				},
				notPassword: function(elem){
					alert("\u8bf7\u8f93\u5165\u5bc6\u7801\uff01");//请输入密码！
					elem.focus();
				},
				// notCheckCode: function(){
				// 	alert("\u8bf7\u8f93\u5165\u9a8c\u8bc1\u7801\uff01");//请输入验证码！
				// },
				errorUserName: function(){
					alert("\u7528\u6237\u540d\u6216\u5bc6\u7801\u9519\u8bef\uff01");//用户名或密码错误！
				},
				errorUserBan: function(){
					alert("\u7528\u6237\u88ab\u7981\uff01");//用户被禁！
				},
				// errorCheckCode: function(){
				// 	alert("\u9a8c\u8bc1\u7801\u9519\u8bef\uff01");//验证码错误！
				// },
				errorUncompleted: function(){
					alert("\u672a\u5b8c\u6210\u6ce8\u518c\uff01");//未完成注册！
				},
				errorUsernameDisabled: function(){
					alert("\u7528\u6237\u540d\u4e0d\u53ef\u7528\uff01");//用户名不可用！
				},
				loginIpLock: function(){
					alert("IP\u5df2\u88ab\u7981\u7528\uff01");//IP已被禁用！
				},
				errorUrlError: function(){
					alert("\u8bf7\u6c42\u5730\u5740\u9519\u8bef\uff01");//请求地址错误！
				},
				errorParamError: function(){
					alert("\u53c2\u6570\u9519\u8bef\uff01");//参数错误！
				},
				errorFrequent: function(){
					alert("\u8bbf\u95ee\u592a\u9891\u7e41\uff0c\u8bf7\u7a0d\u540e\u8bbf\u95ee\uff01");//访问太频繁，请稍后访问！
				},
				errorIpRestricted: function(){
					alert("IP\u5730\u5740\u53d7\u9650\uff01");//IP地址受限！
				},
				errorServer: function(){
					alert("\u5176\u4ed6\u9519\u8bef\uff01");//其他错误！
				},
				errorOut: function(){
					alert("\u9000\u51fa\u5931\u8d25\uff0c\u8bf7\u91cd\u65b0\u64cd\u4f5c\uff01");//退出失败，请重新操作！
				}
			}
		});
		
		// 配置中报错方法收集
		if(o.error){
			for(var n in o.error){
				if(typeof o.error[n] == "function"){
					this.params.error[n] = o.error[n];
				};
			}
		}
		// 配置中成功执行方法收集
		if(o.succeed){
			for(var n in o.succeed){
				if(typeof o.succeed[n] == "function"){
					this.params.succeed[n] = o.succeed[n];
				};
			}
			
			this.params.succeed.loginOkUrl = o.succeed.loginOkUrl || "";
			this.params.succeed.outOkUrl = o.succeed.outOkUrl || "";
		}
	};
	
	Login.prototype.setHTML = function(){
		var elem = this.params.elem;
		if(!this.getCookie("username") || !this.getCookie("ticket")){
			elem.innerHTML = this.getInitHTML();
			this.setForm();
			this.addFormEvent();
		}else{
			elem.innerHTML = this.getLogonHTML();
			this.loginOk();
		}
	};
	
	Login.prototype.getInitHTML = function(){
		var initStr;
		if(!this.params.initHTML){
			initStr = '{F7:form}';
			initStr += '<p class="userName">';
			initStr += '<em>';
			initStr += "\u7528\u6237\u540d\uff1a";//用户名：
			initStr += '</em>';
			initStr += '<label>{F7:username /}</label>';
			initStr += '</p>';
			initStr += '<p class="password">';
			initStr += '<em>';
			initStr += "\u5bc6\u7801\uff1a";//密码：
			initStr += '</em>';
			initStr += '<label>{F7:password /}</label>';
			initStr += '</p>';
			initStr += '<p class="loginLink">';
			initStr += '<a href="https://passport.china.com/logon.do?processID=register1" class="loginReg">';
			initStr += "\u6ce8\u518c\u5e10\u53f7";//注册帐号
			initStr += '</a>';
			initStr += '<a href="https://passport.china.com/jsp/user/findpassword.jsp" class="loginLose">';
			initStr += "\u5fd8\u8bb0\u5bc6\u7801\uff1f";//忘记密码？
			initStr += '</a>';
			initStr += '</p>';
			initStr += '<p class="loginBut">';
			initStr += '<label class="loginSubmit"><input type="submit" name="button" value="\u767b\u5f55" /></label>';//登录
			initStr += '<label class="loginReset"><input type="reset" name="button" value="\u91cd\u7f6e" /></label>';//重置
			initStr += '</p>';
			initStr += '{/F7:form}';
			
			this.params.initHTML = initStr;
		};
		return this.converter(this.params.initHTML);// 自定义标签转换器
	};
	
	Login.prototype.getLogonHTML = function(){// 设置登录成功后的HTML代码
		var logomStr, hours;
		if(!this.params.logonHTML){
			logomStr = '<div class="logon">';
			logomStr += '<em class="logonGreet">';
			hours = new Date().getHours();
			if(hours < 12){
				logomStr += "\u65e9\u4e0a\u597d\uff01";//早上好！
			}else if(hours > 18){
				logomStr += "\u665a\u4e0a\u597d\uff01";//晚上好！
			}else{
				logomStr += "\u4e0b\u5348\u597d\uff01";//下午好！
			};
			logomStr += '</em>';
			logomStr += '<em class="logonName">[F7:nickname /]</em>';
			logomStr += '<em class="logonOut">[F7:out /]</em>';
			logomStr += '</div>';

			this.params.logonHTML = logomStr;
		};

		return this.converter(this.params.logonHTML);// 自定义标签转换器
	};
	
	// 自定义标签转换器
	Login.prototype.converter = function(msg){
		// 提取 {F7:form} 类型成功
		//var parse_html = /{F7.\w*}/g;
		//alert(params.initHTML.match(parse_html));
		// 提取 {/F7:form} 类型成功
		//var parse_html2 = /({\/F7:{1}).\w*}/g;
		//alert(params.initHTML.match(parse_html2));
		// 提取 {F7:username /} 类型成功
		//var parse_html3 = /({F7:{1}).\w*.(\/}{1})/g;
		//alert(params.initHTML.match(parse_html3));
		// 提取 [F7:nickname /] 类型成功
		//var parse_html4 = /(\[F7:{1}).\w*.(\/\]{1})/g;
		//alert(params.initHTML.match(parse_html4));

		// 提取所有标签的正则
		var parse_html = /{F7.\w*}|({\/F7:{1}).\w*}|({F7:{1}).\w*.(\/}{1})|(\[F7:{1}).\w*.(\/\]{1})/g;
		var that = this;
		
		msg = msg.replace(parse_html, function(word){
			if(word === "{F7:form}"){
				if(that.params.hiddenForm){
					return that.params.tag_form + that.params.hiddenForm;
				}else{
					return that.params.tag_form;
				};
			};
			if(word === "{/F7:form}") return '</form>';
			/*
			if(word === "{F7:username /}" || word === "{F7:username/}"){// 针对用户名表单做的特殊处理，实现处是文字及得到焦点变化
				that.params.tag_username = that.params.tag_username.replace('value=""', 'value="'+ that.params.userNameInitValue +'"');
				return that.params.tag_username;
			};*/
			if(word === "{F7:username /}" || word === "{F7:username/}") return that.params.tag_username;
			if(word === "{F7:password /}" || word === "{F7:password/}") return that.params.tag_password;
			if(word === "{F7:select_cookietime /}" || word === "{F7:select_cookietime/}" || word === "{F7:select_cookieTime /}" || word === "{F7:select_cookieTime/}") return that.params.tag_select_cookietime;
			if(word === "{F7:checkbox_cookietime /}" || word === "{F7:checkbox_cookietime/}" || word === "{F7:checkbox_cookieTime /}" || word === "{F7:checkbox_cookieTime/}") return that.params.tag_checkbox_cookietime;

			if(word === "[F7:nickname /]" || word === "[F7:nickname/]") return that.getCookie("username");
			if(word === "[F7:out /]" || word === "[F7:out/]") return that.params.tag_out;
		});
		return msg;
	};
	
	// 设置form的相关value及表单样式状态
	Login.prototype.setForm = function(str){
		if(!document[this.params.name +"_form"]) return false;
		var elem = document[this.params.name +"_form"],
		text = elem.username,
		pass = elem.password;
		var nameValue = this.params.userNameInitValue,
			passValue = this.params.passwordInitValue;
		
		if(!str){
			// 初始化用户名状态
			if ( text.value == "" || text.value == nameValue ) {
				if ( isIE && isIE < 10 ) {
					text.value = nameValue;
				} else {
					text.placeholder = nameValue;
				};
				text.className = "dead";
			} else {
				text.className = "";
			};
			
			/*
			if ( this.getCookie("china_login_userID") && (text.value == "" || text.value == nameValue) ) {
				text.value = this.getCookie("china_login_userID");
				text.className = "";
				this.setForm();
			};*/
			
			// 初始化密码状态
			if ( pass.value == "" ) {
				if ( isIE && isIE < 10 ) {
					// IE9及以下浏览器不支持placeholder属性
				} else {
					pass.placeholder = passValue;
				};
				pass.className = "dead";
			} else {
				pass.className = "";
			};
			pass.value == "" ? pass.className = "dead" : pass.className = "";
		};
		
		// 得到焦点是的处理
		if(str == "text"){
			/*
			if(text.value == nameValue){
				text.value = "";
				text.className = "current focus";
			}else{
				text.className = "current";
				
			}*/
			if(text.value == nameValue){
				text.value = "";
			}
			text.className = "current";
		}
		
		if(str == "password"){
			/*if(pass.value == ""){
				pass.className = "current focus";
			}else{
				pass.className = "current";
			}*/
			pass.className = "current";
		}
	};
	
	Login.prototype.addFormEvent = function(){
		if(!document[this.params.name +"_form"]) return false;
		var elem = document[this.params.name +"_form"],
		text = elem.username,
		pass = elem.password,
		that = this;
		//console.log(/msie (\d+\.\d)/i.test(navigator.userAgent));
		// 得到焦点监控
		text.onfocus = function(){
			that.setForm("text");
		};
		pass.onfocus = function(){
			that.setForm("password");
		};
		// 失去焦点监控
		text.onblur = function(){
			that.setForm();
			this.value = that.trim(this.value);
		};
		pass.onblur = function(){
			that.setForm();
		};
		
		// 变化监控
		// 此功能失败总结，监控表单元素在发生变时修改本节点属性IE会报堆栈溢出，attachEvent方法注册监控变化事件可以修正IE9的堆栈溢出，可是IE8及以下还会报错，但修改父标签节点属性没问题，不过由于该组件要与以前版本对接，不变采用其他方法处理，所以暂时放弃
		/*
		//(/msie (\d+\.\d)/i.test(navigator.userAgent)) ? text.onpropertychange = changeText : text.addEventListener("input", changeText, false);
		//(/msie (\d+\.\d)/i.test(navigator.userAgent)) ? pass.onpropertychange = changePass : pass.addEventListener("input", changePass, false);
		
		if(text.addEventListener){
			text.addEventListener("input", changeText, false);
			pass.addEventListener("input", changePass, false);
		}else if(text.attachEvent){
			text.attachEvent('onpropertychange', changeText);
			pass.attachEvent('onpropertychange', changePass);
		}
		
		function changeText(){
			if(text.value === ""){
				text.className = "current focus";
			}else{
				text.className = "current";
			}
		};
		function changePass(){
			if(pass.value === ""){
				pass.className = "current focus";
			}else{
				pass.className = "current";
			}
		};*/
		//console.log(elem);
		//alert("a");
		elem.onsubmit = function(){ that.checkForm(); return false; };
	};
	
	Login.prototype.checkForm = function(){
		//console.log(this.params.name);
		var elem = document[this.params.name +"_form"];
		
		if(!elem.username.value || elem.username.value == this.params.userNameInitValue){
			this.params.error.notUserName(elem.username);
			return false;
		};
		if(!elem.password.value){
			this.params.error.notPassword(elem.password);
			return false;
		};
		if(elem.checkbox_cookietime && elem.checkbox_cookietime.checked){
			elem.cookietime.value = 2592000;
		};
		
		this.submit();
		return false;
	};
	
	// get方式，暂时不用，改post了
	Login.prototype.submit_BAK = function(){
		var s, url, params, hiddenParams, _ins, elem = document[this.params.name +"_form"];
		
		s = document.createElement("script");
		url = this.params.loginUrl;
		// 拼接参数
		params = "username="+ encodeURI(this.trim(elem.username.value)) +"&password="+ elem.password.value;
		
		// 添加cookietime字段
		if(elem.cookietime){
			params += "&cookietime="+ elem.cookietime.value;
		}else{
			params += "&cookietime=-1";
		}
		
		// 添加隐藏字段
		_ins = elem.getElementsByTagName("input");
		for(var i=0,l=_ins.length; i<l; i++){
			if(_ins[i].getAttribute("type") == "hidden"){
				params += "&"+ _ins[i].getAttribute("name") +"="+ _ins[i].getAttribute("value");
			}
		};
		params += "&jsonpcallback=" + this.params.name +".callback";
		
		s.src = url +"?"+ params;
		//alert(s.src);
		//console.log(s.src);
		//提交之前插入submitAfterFn
		if(this.params.submitAfterFn) this.params.submitAfterFn();

		document.getElementsByTagName("head")[0].appendChild(s);
	};
	// post方式
	Login.prototype.submit = function(){
		var s, url, params, hiddenParams, _ins, elem = document[this.params.name +"_form"],
			fn = this.params.name;
		
		url = this.params.loginUrl;
		// 拼接参数
		params = {};

		params.username = encodeURI(this.trim(elem.username.value));
		params.password = elem.password.value;

		// 添加cookietime字段
		if(elem.cookietime){
			params.cookietime = elem.cookietime.value;
		}else{
			params.cookietime = "-1";
		}
		
		// 添加隐藏字段
		_ins = elem.getElementsByTagName("input");
		for(var i=0,l=_ins.length; i<l; i++){
			if(_ins[i].getAttribute("type") == "hidden"){
				params[_ins[i].getAttribute("name")] = _ins[i].getAttribute("value");
			}
		};
		
		//alert(s.src);
		//console.log(s.src);
		//提交之前插入submitAfterFn
		if(this.params.submitAfterFn) this.params.submitAfterFn();

		postJSONP(this.params.loginUrl, params, function(str){
			eval("var data = "+str);
			window[fn].callback(data);
		});
	};
	
	Login.prototype.out = function(){
		if(confirm(typeof login_en_lan_confirm == "string"?login_en_lan_confirm:"Confirm logout?")){//确认退出？
			getScript("https://passport.china.com/chinaapi/jsonp/userLogout", "ticket="+ this.getCookie("ticket") +"&jsonpcallback="+ this.params.name +".outCallback");
			return false;
		};
	};
	
	Login.prototype.loginOk = function(){
		// 对配置参数指定跳转URL进行优先处理
		if(this.params.succeed.loginOkUrl){
			window.location = this.params.succeed.loginOkUrl;
			return false;
		}
		
		// 执行成功后的回调
		if(this.params.succeed.loginOk) this.params.succeed.loginOk();
	};
	Login.prototype.outOk = function(){
		// 清楚Cookie
		clearCookie("nickname");
		clearCookie("ticket");
		clearCookie("username");

		login_batch();// 多点处理
		
		// 对配置参数指定跳转URL进行优先处理
		if(this.params.succeed.outOkUrl){
			window.location = this.params.succeed.outOkUrl;
			return false;
		}
		
		// 执行成功后的回调
		if(this.params.succeed.outOk) this.params.succeed.outOk();
	};
	
	Login.prototype.firstLogin = function(){// 手动登录
		
		login_batch();// 多点处理
		
		if(this.params.succeed.firstLogin) this.params.succeed.firstLogin();
	};
	
	Login.prototype.callback = function(data){
		if(this.params.submitBackFn) this.params.submitBackFn();

		var flag = data.state;
		if(flag === 0){// 登录成功
			// 当前跨域登录有效期是一小时，所以登录cookie只设置了1小时
			if ( data.ticket ) {
				this.setCookie("ticket", data.ticket, 1000*60*60);
			}
			if ( data.userinfo.username ) {
				this.setCookie("username", data.userinfo.username, 1000*60*60);
			}
			if ( data.userinfo.nickname ) {
				this.setCookie("nickname", data.userinfo.nickname, 1000*60*60);
			}

			this.firstLogin();
		}else if(flag === 1){// 用户名或密码错误
			this.params.error.errorUserName();
		}else if(flag === 3){// 用户被禁！
			this.params.error.errorUserBan();
		}else if(flag === 6){// 未完成注册！
			this.params.error.errorUncompleted();
		}else if(flag === 7 || flag === 8){// 用户名不可用！
			this.params.error.errorUsernameDisabled();
		}else if(flag === 9){// IP已被禁用！
			this.params.error.loginIpLock();
		}else if(flag === 10){// 请求地址错误！
			this.params.error.errorUrlError();
		}else if(flag === 11){// 参数错误！
			this.params.error.errorParamError();
		}else if(flag === 12){// 访问太频繁，请稍后访问！
			this.params.error.errorFrequent();
		}else if(flag === 96){// IP地址受限！
			this.params.error.errorIpRestricted();
		}else{// 系统抛出异常
			this.params.error.errorServer();
		};
	};
	
	Login.prototype.outCallback = function(data){
		var flag = data.state;
		if (flag === 0) {// 退出成功
			this.outOk();
		} else {// 退出失败
			this.params.error.errorOut();
		}
	};

	// 分解创建实例
	var stack_login = function(o){
		var name;
		if(typeof o === "string") {// 处理只传一个字符串进来的情况
			o = {id:o};
		}
		
		if(!o.id) return false;
		if(o.id.nodeType == 1){// Element
			if(o.id.getAttribute("id")){// 节点有ID属性
				name = "china_api_login_" + o.id.getAttribute("id");
			}else{// 没有时随机
				name = "china_api_login_" + new Date().getTime();
			}
		}else{// string
			if(!document.getElementById(o.id)) return false;
			name = "china_api_login_" + o.id;
		}
		name = name.replace(/-/g, "_");
		o.name = name;
		login_instantiation.push(name);
		window[name] = new Login(o);
		//alert(name);
	};
	

	function postJSONP(url, data, fn){  
		var form = document.createElement("form");
		form.id = form.name = 'postForm';
		//创建表单数据
		if (data) {
			for(var key in data) {
				var input = document.createElement("input");
				input.type = "hidden";
				input.name = key;
				input.value = data[key];
				form.appendChild(input);
			}
		}
		//创建iframe
		var iframe = null;
		//try&catch是为了解决IE67创建iframe新开窗问题
		try {
		  iframe = document.createElement('<iframe name="postIframe">');
		} catch (ex) {
		  iframe = document.createElement('iframe');
		}
		iframe.id = iframe.name = "postIframe";
		iframe.width = "1";
		iframe.height = "1";
		iframe.style.display = "none";
		document.body.appendChild(iframe);
		//表单提交
		document.body.appendChild(form);
		form.action = url;
		form.target = iframe.name;
		form.method = "post";
		form.submit();
		//事件处理
		if(iframe.attachEvent){
			iframe.attachEvent("onload", _loadFn);
		}else{
			iframe.onload = _loadFn;
		}
		//记录iframe的加载状态
		iframe.state = 0;
		function _loadFn() {
			if (iframe.state === 1) {
				var data = '';
				//获取window.name保存的数据
				try{
					data = iframe.contentWindow.name;
				}catch(e){
					console.log(e);
				}
				var json = data;
				try {
					json = Kg.JSON.parse(data);
				} catch(e){}
				//执行回调方法
				_callback(json);
				//iframe清除
				iframe.onload = null; 
				document.body.removeChild(iframe);
			} else if (iframe.state === 0) {
				//form提交完成之后，将location置为同域
				iframe.state = 1;
				iframe.contentWindow.location = "/china_login_blank.html";
			}
		}
		function _callback(json) {
			//默认执行传入的回调方法
			if (fn && typeof fn === "function") {
				fn(json);
			} else {
				//没有回调方法则解析postcallback
				var svalue = url.match(new RegExp("[\?\&]postcallback=([^\&]*)(\&?)"));
				fn = window[svalue ? svalue[1] : svalue];
				if (fn && typeof fn === "function") {
					fn(json);
				}
			}
		}
		return false;
	};


	window.china_api_login = stack_login;
})(window);
